!     DATELIB
!    
!     BIBLIOTECA DE FUNCOES PARA PROCESSAR DATAS E HORAS EM FORTRAN



	module datelib
	
	private 
	
	
	type tpmonth
	 integer::nm
	end type

	type (tpmonth),DIMENSION(12)::monthy
	
	PUBLIC fjulian 
	
	CONTAINS

	subroutine init(year) 
	 integer,intent(in)::year
	 
	 monthy(1)%nm=31 !'jan
	 monthy(2)%nm=28 !'fev
	 monthy(3)%nm=31 ! 'mar
	 monthy(4)%nm=30 ! 'apr
	 monthy(5)%nm=31 ! 'may
	 monthy(6)%nm=30 ! 'jun
	 monthy(7)%nm=31 ! 'jul
	 monthy(8)%nm=31 ! 'ago
	 monthy(9)%nm=30 ! 'sep
	 monthy(10)%nm=31 !'oct
	 monthy(11)%nm=30 ! 'nov
	 monthy(12)%nm=31 !'dec
	  
	 if (mod(year,4)==0) monthy(2).nm=29

	 
	end subroutine
	
	!----------------------------------------------
	! fjulian - Retorna a data corrente a partir do ano 0 
	!           depois de cristo em dia e fracao de dias  
	!           	! 
	!----------------------------------------------
	
	           
	function fjulian(year,month,day,hour,min,sec)
	 real*8::fjulian
	 integer,intent(in)::year,month,day,hour,min,sec
	 
	 real d,h
	 d=0;h=0
	  

	  call init(year)

	  
	  do i=0,(year-1),4
	   d=d+1
	  end do
	  
	  d=d+365*year
	  
	  do i=2,month,1
	  
	   d=d+monthy(i-1)%nm
	   
	  end do   
	  
	  
	  d=d+day
	  
	  h=hour+min*0.6+sec*0.6*0.6
	  
	  d=d+h/24
	 
	  fjulian=d
	  
	end function
	
!=======================================
END MODULE


	
